\documentclass[a4paper, trou]{tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}
\input{macro}
\input{tpl/listing-config}

  
\graphicspath{{tpl/}{img/}}
\ddmodulename{Informatique}
\ddmodulenumber{Machine learning}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien




\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  

\newdnnexo{04}{The sigmoid transfer function}

\noindent The previous tutorial highlights the difficulty of the
Perceptron to deal with overlapping data. A better approach, instead of using a unit step function that generates only \texttt{'0'} and
\texttt{'1'}  consists in generating a
continuum score in the $[0, 1]$ range.
\begin{itemize}
\item A score closes to $0$ means that a
  point as a high probability to belong to the \texttt{'0'} class.
\item A score closes to $1$ means that a point as a high probability
  to belong to the \texttt{'1'} class.
\end{itemize}
A good function to do this job, is the \textit{sigmoid function}
which is drawn below.

\begin{center}
  \svg{.4\linewidth}{./img/sigmoid.pdf_tex}
\end{center}

\begin{manip}
  Thanks to the first tutorial, create a Python environment \texttt{(dnn)} and launch the \textbf{thonny} editor.
\end{manip}

\begin{manip}
  Download the
  \href{https://gitlab.com/damien.andre/learning-python-for-science/blob/master/script/dnn/mltool.py}{\texttt{mltool.py}}, 
  \dltutodnn{04}{data.txt} and \dltutodnn{04}{label.txt} files and put them in your current working dir.
\end{manip}

\begin{manip}
  Download the \dltutodnn{04}{tuto-04.py} script file and
  execute it with \textbf{thonny}. This file will be used as starting point for
  this tutorial.
\end{manip}

\section*{Mathematical definition of a sigmoid}

 The equation of the sigmoid function $\sigma(x)$ is given by:
\begin{equation}
  \sigma(x) = \frac{1}{1+e^x}\nonumber
\end{equation}

\begin{task}
  From the script below, Implement the sigmoid as a Python function.
  \vspace*{-1.5\baselineskip}
\begin{lstlisting}
def sigmoid(x):
    # ... complete here
\end{lstlisting}
  \end{task}

  
\begin{task}
  Now, use this \keyw{sigmoid(x)} function as the transfer function for the feed forwarding rule instead of the unit step function
\end{task}

\begin{info}
  The correction of this part is given by \dltutodnn{04}{tuto-04\_correction-part1.py}
\end{info}

\section*{Introducing probability}
The sigmoid function allows us to introduce
probability in our Perceptron:
\begin{enumerate}
\item if the sigmoid gives a value close to $1$, it means that
  the related point has a strong probability to belong to the
  \texttt{'1'} class and
\item if the sigmoid function gives a value close to $0$, it means that
  the related point has a strong probability to belong to the
  \texttt{'0'} class,
\item otherwise, the point can not be defined and a high uncertainty remains
  on its class.
\end{enumerate}

A simple approach consists in defining thresholds in order to classify
input. For example, as shown on the figure below, we can consider a threshold of 20\%.
It means that:
\begin{enumerate}
\item if the score is lower than $0.2$, the point is considered as belonging to the \texttt{'0'} class,
\item if the score is higher than $0.8$, the point is considered as belonging to the \texttt{'1'} class,
\item otherwise the point class is considered as uncertain (we can use the undefined \texttt{'-1'} class).
\end{enumerate}
\begin{center}
    \svg{.4\linewidth}{./img/sigmoid-class.pdf_tex}
  \end{center}

\begin{task}
  Edit the \keyw{predict(X)} function for introducing this
  probability/uncertainty in order to obtain the chart below.
\begin{center}
  \svg{.6\linewidth}{./img/perceptron-sigmoid.pdf_tex}
\end{center}
\end{task}

\begin{info}
  The correction of this part is given by \dltutodnn{04}{tuto-04\_correction-part2.py}
\end{info}

\section*{Conclusion}

Another advantage of using this kind of continuous function comes from
that the sigmoid function is fully \textbf{derivable}. This property
can be used advantageously for optimizing the backward propagation
process with the \textit{gradient descent} algorithm and loss
functions. The next tutorial will introduce this highly important
concept.


\end{document}
